import checkers.igj.quals.*;

/**
 * This class is for testing Template immutability
 *
 * @author mahmood
 */
@I
class Test {
    @I Test field;
    @Assignable @I Test assignable;
    @I Test getField() @ReadOnly { return field; }

    @I("O") Test getField(@I("O") Test o) @ReadOnly {
        this.assignable = assignable;
        assignable = this.assignable;
        this.assignable = o.assignable;  // emit error
        assignable = o.assignable;  // emit error
        o.assignable = assignable;  // emit error
        o.assignable = o.assignable;
        @I("O") Test f1 = o.field;
        @I("O") Test f2 = this.field; // emit error
        @I("O") Test f3 = field;     // emit error
        f1 = o.field;
        f1 = this.field; // emit error
        f1 = field;  // emit error
        return o.field;
    }

    static @I("O") Test getSame(@I("O") Test o) { return o; }

    void testOneParam() {
        @Mutable Test mutable = null;
        @Immutable Test immutable = null;
        @ReadOnly Test readOnly = null;

        mutable = getSame((@Mutable Test)null);
        immutable = getSame((@Mutable Test)null);     // emit error
        readOnly = getSame((@Mutable Test)null);

        mutable = getSame((@Immutable Test)null);     // emit error
        immutable = getSame((@Immutable Test)null);
        readOnly = getSame((@Immutable Test)null);

        mutable = getSame((@ReadOnly Test)null);    // emit error
        immutable = getSame((@ReadOnly Test)null);  // emit error
        readOnly = getSame((@ReadOnly Test)null);
    }

    static @I("0") Test get() { return null; }

    void testUnidentified() {
    @Mutable Test mutable = null;
        @Immutable Test immutable = null;
        @ReadOnly Test readOnly = null;

    mutable = get();
    immutable = get();
    readOnly = get();
    }

    static @I("1") Test getUpperBound(@I("1") Test o1, @I("1") Test o2) {
        return null;
    }

    void testUpperBoundWithConcrete() {
        @Mutable Test mutable = null;
        @Immutable Test immutable = null;
        @ReadOnly Test readOnly = (@ReadOnly Test) null;

        {
            @Mutable Test t1 = getUpperBound(mutable, mutable);
            @Mutable Test t2 = getUpperBound(mutable, immutable);   // invalid
            @Mutable Test t3 = getUpperBound(mutable, readOnly);    // invalid
            @Mutable Test t4 = getUpperBound(immutable, mutable);   // invalid
            @Mutable Test t5 = getUpperBound(immutable, immutable); // invalid
            @Mutable Test t6 = getUpperBound(immutable, readOnly);  // invalid
            @Mutable Test t7 = getUpperBound(readOnly, mutable);    // invalid
            @Mutable Test t8 = getUpperBound(readOnly, immutable);  // invalid
            @Mutable Test t9 = getUpperBound(readOnly, readOnly);   // invalid
        }

        {
            @Immutable Test t1 = getUpperBound(mutable, mutable);   // invalid
            @Immutable Test t2 = getUpperBound(mutable, immutable); // invalid
            @Immutable Test t3 = getUpperBound(mutable, readOnly);  // invalid
            @Immutable Test t4 = getUpperBound(immutable, mutable); // invalid
            @Immutable Test t5 = getUpperBound(immutable, immutable);
            @Immutable Test t6 = getUpperBound(immutable, readOnly);// invalid
            @Immutable Test t7 = getUpperBound(readOnly, mutable);  // invalid
            @Immutable Test t8 = getUpperBound(readOnly, immutable);// invalid
            @Immutable Test t9 = getUpperBound(readOnly, readOnly); // invalid
        }

        {
            @ReadOnly Test t1 = getUpperBound(mutable, mutable);
            @ReadOnly Test t2 = getUpperBound(mutable, immutable);
            @ReadOnly Test t3 = getUpperBound(mutable, readOnly);
            @ReadOnly Test t4 = getUpperBound(immutable, mutable);
            @ReadOnly Test t5 = getUpperBound(immutable, immutable);
            @ReadOnly Test t6 = getUpperBound(immutable, readOnly);
            @ReadOnly Test t7 = getUpperBound(readOnly, mutable);
            @ReadOnly Test t8 = getUpperBound(readOnly, immutable);
            @ReadOnly Test t9 = getUpperBound(readOnly, readOnly);
        }
    }

    void testUpperBoundWithImmutabilityVar() {
        @I("1") Test tm1 = null;
        @I("2") Test tm2 = null;

        {
            @I("1") Test t1 = getUpperBound(tm1, tm1);
            @I("2") Test t2 = getUpperBound(tm1, tm1);  // invalid
            @Mutable Test t3 = getUpperBound(tm1, tm1); // invalid
            @Immutable Test t4 = getUpperBound(tm1, tm1);   // invalid
            @ReadOnly Test t5 = getUpperBound(tm1, tm1);
        }

        {
            @I("1") Test t1 = getUpperBound(tm1, tm2);  // invalid
            @I("2") Test t2 = getUpperBound(tm1, tm2);  // invalid
            @Mutable Test t3 = getUpperBound(tm1, tm2); // invalid
            @Immutable Test t4 = getUpperBound(tm1, tm2);   // invalid
            @ReadOnly Test t5 = getUpperBound(tm1, tm2);
        }

        {
            @I("1") Test t1 = getUpperBound(tm2, tm2);  // invalid
            @I("2") Test t2 = getUpperBound(tm2, tm2);
            @Mutable Test t3 = getUpperBound(tm2, tm2); // invalid
            @Immutable Test t4 = getUpperBound(tm2, tm2);   // invalid
            @ReadOnly Test t5 = getUpperBound(tm2, tm2);
        }

    }
}
