import checkers.nullness.quals.*;
public class Boxing {
    void withinOperation() {
        Integer i1 = 3;
        int i1u = i1 + 2;         // valid
        Integer i2 = null;
        int i2u = i2 + 2;         // invalid
    }

    void withinAssignment() {
        Integer i1 = 5;
        int i1u = i1;
        Integer i2 = null;
        int i2u = i2;       // invalid
    }

    void validWithinUnary() {
        // within blocks to stop flow
        Integer i1 = 1, i2 = 1, i3 = 1, i4 = 1;
        ++i1;
        i2++;
    }

    void invalidWithinUnary() {
        // within blocks to stop flow
        Integer i1 = null, i2 = null, i3 = null, i4 = null;
        ++i1;       // invalid
        i2++;       // invalid
    }

    void validCompoundAssignmentsAsVariable() {
        @NonNull Integer i = 0; // nonnull is needed because flow is buggy
        i += 1;
        i -= 1;
        @NonNull Boolean b = true;
        b &= true;
    }

    void invalidCompoundAssignmentsAsVariable() {
        Integer i = null;
        i += 1;         // invalid
        Boolean b = null;
        b &= true;      // invalid
    }
    
    void invalidCompoundAssignmentAsValue() {
        @NonNull Integer var = 3;
        Integer val = null;
        var += val;
        Boolean b1 = null;
        boolean b2 = true;
        b2 &= b1;     // invalid
    }
    
    void randomValidStringOperations() {
        String s = null;
        s += null;
    }
}
